<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
	<div>
		<el-form :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''"
				 label-width="100px" @submit.native.prevent>

			<el-divider content-position="left"><i class="el-icon-document"></i> 银行卡信息</el-divider>
			<el-row :gutter="26">
				<el-col :span="12">
					<el-form-item label="姓名" prop="name" :rules="[{required: true, message: '姓名不能为空', trigger: 'blur'}]">
						<el-input :disabled="true" v-model="inputForm.name"></el-input>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="银行卡号" prop="bankCardNumber" :rules="[{required: true, message: '银行卡号不能为空', trigger: 'blur'}]">
						<el-input v-model="inputForm.bankCardNumber" maxlength="19" @change="checkBankNumber(inputForm.bankCardNumber)"></el-input>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="银行卡正面" prop="accountHolderFront" :rules="[
						{required: true, message: '银行卡正面不能为空', trigger: 'blur'}
					]">
						<el-upload :action="`${$http.BASE_URL}/public-modules-server/oss/file/webUpload/upload`"
								   :limit="limitNum"
								   :disabled="hideUploadEdit"
								   list-type="picture-card"
								   :auto-upload="true"
								   :on-success="handleUploadSuccess"
								   v-model:file-list="fileList"
						>
							<el-icon><Plus /></el-icon>

							<template #file="{ file }">
								<div>
									<img class="el-upload-list__item-thumbnail" :src="file.url" alt="" />
									<span class="el-upload-list__item-actions">
										  <span
											  class="el-upload-list__item-preview"
											  @click="handlePictureCardPreview(file)"
										  >
											<el-icon><zoom-in /></el-icon>
										  </span>
										  <span
											  v-if="!disabled"
											  class="el-upload-list__item-delete"
											  @click="handleDownload(file)"
										  >
											<el-icon><Download /></el-icon>
										  </span>
										  <span
											  class="el-upload-list__item-delete"
											  @click="handleRemove(file,fileList)"
										  >
											<el-icon><Delete /></el-icon>
										  </span>
									</span>
								</div>
							</template>
						</el-upload>
						<el-dialog v-model="dialogVisible">
							<img w-full :src="inputForm.accountHolderFrontUrl" alt="Preview Image" :style="{ maxWidth: '100%', maxHeight: '100%' }"/>
						</el-dialog>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="银行卡反面" prop="accountHolderOpposite" :rules="[
						{required: true, message: '银行卡反面不能为空', trigger: 'blur'}
					]">
						<el-upload :action="`${$http.BASE_URL}/public-modules-server/oss/file/webUpload/upload`"
								   :limit="limitNum"
								   :disabled="hideUploadEdit2"
								   list-type="picture-card"
								   :auto-upload="true"
								   :on-success="handleUploadSuccess2"
								   v-model:file-list="fileList2"
						>
							<el-icon><Plus /></el-icon>

							<template #file="{ file }">
								<div>
									<img class="el-upload-list__item-thumbnail" :src="file.url" alt="" />
									<span class="el-upload-list__item-actions">
										  <span
											  class="el-upload-list__item-preview"
											  @click="handlePictureCardPreview2(file)"
										  >
											<el-icon><zoom-in /></el-icon>
										  </span>
										  <span
											  v-if="!disabled"
											  class="el-upload-list__item-delete"
											  @click="handleDownload2(file)"
										  >
											<el-icon><Download /></el-icon>
										  </span>
										  <span
											  class="el-upload-list__item-delete"
											  @click="handleRemove2(file,fileList)"
										  >
											<el-icon><Delete /></el-icon>
										  </span>
									</span>
								</div>
							</template>
						</el-upload>
						<el-dialog v-model="dialogVisible2">
							<img w-full :src="inputForm.accountHolderOppositeUrl" alt="Preview Image" :style="{ maxWidth: '100%', maxHeight: '100%' }"/>
						</el-dialog>
					</el-form-item>
				</el-col>
				<el-col :span="12">
					<el-form-item label="简介" prop="remarks" :rules="[]">
						<el-input type="textarea"
								  maxlength="200" placeholder="请输入简介"
								  show-word-limit v-model="inputForm.remarks"></el-input>
					</el-form-item>
				</el-col>
			</el-row>
		</el-form>
	</div>
</template>

<script>
	import OSSSerivce, {
		httpRequest,
		fileName,
		toHref,
	} from '@/api/sys/OSSService'
	import registerBankService from '@/api/human/register/RegisterBankService'

	export default {
		props: {
			businessId: {
				type: String,
				default: ''
			},
			formReadOnly: {
				type: Boolean,
				default: false
			},
			status: {
				type: String,
				default: ''
			}
		},
		data () {
			return {
				title: '',
				method: '',
				visible: false,
				testDisabledFlag: false,
				loading: false,
				limitNum: 1,
				disabled: false,
				dialogVisible: false,
				dialogVisible2: false,
				hideUploadEdit: false, //控制上传点击
				hideUploadEdit2: false, //控制上传点击
				fileList: [],
				fileList2: [],
				inputForm: {
					userId: '',
					remarks: '',
					type: '',
					bankCardNumber: '',
					name: '',
					accountHolderFront: '',
					accountHolderFrontUrl: '',
					accountHolderOpposite: '',
					accountHolderOppositeUrl: '',
				},
				keyWatch: '',
				amountKey: '',
				membersKey: ''
			}
		},
		created () {
			this.ossService = new OSSSerivce()
		},
		components: {
		},
		computed: {
			bus: {
				get () {
					return this.businessId
				},
				set (val) {
					this.businessId = val
				}
			},
			name () {
				return this.$store.state.user.name
			},
			userId () {
				return this.$store.state.user.id
			}
		},
		watch: {
			'keyWatch': {
				handler (newVal) {
					if (this.commonJS.isNotEmpty(this.bus)) {
						this.init('', this.bus)
					} else {
						this.$nextTick(() => {
							this.$refs.inputForm.resetFields()
						})
					}
				}
			},
			'loading': {
				handler (newVal) {
					this.$emit('changeLoading', newVal)
				}
			}
		},
		methods: {
			checkBankNumber(bankNumber) {
				if (!this.validateXG.isBankNum(bankNumber)) {
					this.$message.error('请输入正确的社保银行卡号')
					this.inputForm.bankCardNumber = ''
					throw new Error('请输入正确的社保银行卡号')
				}
			},
			getKeyWatch (keyWatch) {
				this.keyWatch = keyWatch
			},
			getUpload () {
			},
			init (method, id) {
				this.method = method
				this.inputForm = {
					userId: '',
					remarks: '',
					type: '',
					bankCardNumber: '',
					name: '',
					accountHolderFront: '',
					accountHolderFrontUrl: '',
					accountHolderOpposite: '',
					accountHolderOppositeUrl: '',
				}
				if (method === 'add') {
					this.title = `新建实习登记`
				} else if (method === 'edit') {
					this.title = '修改报销类型'
				}
				this.inputForm.id = id
				this.visible = true
				this.loading = false
				this.$nextTick(() => {
					this.loading = true
					registerBankService.findById(this.inputForm.id).then( async (data) => {
						this.fileList = []
						this.fileList2 = []
						if (this.status === 'audit' || this.status === 'taskFormDetail') {
							method = 'view'
						}
						this.inputForm = this.recover(this.inputForm, data)
						this.inputForm = JSON.parse(JSON.stringify(this.inputForm))

						if (this.commonJS.isEmpty(this.inputForm.name)) {
							this.inputForm.name = this.$store.state.user.name
						}
						if (this.commonJS.isNotEmpty(this.inputForm.accountHolderFront)){

							await this.ossService.getTemporaryUrl(this.inputForm.accountHolderFront).then((data) => {
								let file = {
									url: data
								}
								this.fileList.push(file)
								this.hideUploadEdit = true
							})
						}
						if (this.commonJS.isNotEmpty(this.inputForm.accountHolderOpposite)){
							await this.ossService.getTemporaryUrl(this.inputForm.accountHolderOpposite).then((data) => {
								let file = {
									url: data
								}
								this.fileList2.push(file)
								this.hideUploadEdit2 = true
							})
						}
						this.loading = false
					})
				})
			},
			// 表单提交
			doSubmit () {
				this.$refs['inputForm'].validate((valid) => {
					if (valid) {
						this.loading = true

						this.inputForm.id = this.businessId
						registerBankService.save(this.inputForm).then((data) => {
							this.close()
							this.$message.success(data)
							this.$emit('refreshDataList')
							this.loading = false
						}).catch(() => {
							this.loading = false
						})
					}
				})
			},
			close () {
				this.$refs.inputForm.resetFields()
				this.fileList = []
				this.fileList2 = []
				this.visible = false
			},
			reapplyForm (callback) {
				this.loading = true
				registerBankService.findById(this.inputForm.id).then((data) => {
					if (data.type !== '4') { // 审核状态不是“驳回”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
					} else {
						this.startForm(callback)
					}
				})
			},

			// 暂存
			async saveForm (callback) {
				this.loading = true
				this.inputForm.type = '1'
				registerBankService.save(this.inputForm).then((data) => {
					callback()
					this.$refs.inputForm.resetFields()
					this.loading = false
				}).catch(() => {
					this.$refs.inputForm.resetFields()
					this.loading = false
				})
			},
			// 送审
			async startForm (callback) {
				this.$refs['inputForm'].validate(async (valid) => {
					if (valid) {
						this.loading = true
						this.inputForm.type = '2'
						registerBankService.save(this.inputForm).then((data) => {
							this.inputForm.title = `${this.inputForm.name} - [实习登记]`
							this.inputForm.id = data.businessId
							callback(data.businessTable, data.businessId, this.inputForm)
							this.$refs.inputForm.resetFields()
							this.loading = false
						}).catch(() => {
							this.$refs.inputForm.resetFields()
							this.loading = false
						})
					} else {
						this.loading = false
					}
				})
			},

			// 通过
			async agreeForm (callback) {
				this.loading = true
				registerBankService.findById(this.inputForm.id).then((data) => {
					if (data.type !== '2') { // 审核状态不是“审核中”，就弹出提示
						this.loading = false
						this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
					} else {
						this.$refs['inputForm'].validate(async (valid) => {
							if (valid) {
								this.loading = true
								this.inputForm.type = '5'
								console.log('this.inputForm',this.inputForm)
								registerBankService.save(this.inputForm).then((data) => {
									callback(data.businessTable, data.businessId, this.inputForm)
									this.loading = false
								}).catch(() => {
									this.loading = false
								})
							} else {
								this.loading = false
							}
						})
					}
				})
			},
			// 修改状态
			updateStatusById (type, callback) {
				if (type === 'reject') {
					this.loading = true
					registerBankService.findById(this.inputForm.id).then((data) => {
						if (data.type !== '2') { // 审核状态不是“审核中”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						} else {
							this.inputForm.type = '4'
							registerBankService.updateStatusById(this.inputForm).then(() => {
								this.loading = false
								callback()
							})
						}
					})
				} else if (type === 'hold') {
					this.loading = true
					registerBankService.findById(this.inputForm.id).then((data) => {
						if (data.type !== '4') { // 审核状态不是“驳回”，就弹出提示
							this.loading = false
							this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
							throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
						} else {
							this.inputForm.type = '1'
							registerBankService.updateStatusById(this.inputForm).then(() => {
								this.loading = false
								callback()
							})
						}
					})
				}
			},
			handleUploadSuccess(response, file,fileList) {
				return this.handleAvatarSuccess(response,file,fileList,null,'front')
			},
			handleUploadSuccess2(response, file,fileList) {
				return this.handleAvatarSuccess2(response,file,fileList,null,'front')
			},
			handleAvatarSuccess (res, file, fileList, index, val) {
				if (val === 'front') {
					this.inputForm.accountHolderFront = '/' +res.url
					this.inputForm.accountHolderFrontUrl = res.lsUrl
				}
				this.hideUploadEdit = true
				this.$forceUpdate()
			},
			handleAvatarSuccess2 (res, file, fileList, index, val) {
				if (val === 'front') {
					this.inputForm.accountHolderOpposite = '/' +res.url
					this.inputForm.accountHolderOppositeUrl = res.lsUrl
				}
				this.hideUploadEdit2 = true
				this.$forceUpdate()
			},
			handlePictureCardPreview(file) {
				this.dialogImageUrl = file.url;
				this.inputForm.accountHolderFrontUrl = file.url
				this.dialogVisible = true;
			},
			handlePictureCardPreview2(file) {
				this.dialogImageUrl = file.url;
				this.inputForm.accountHolderOppositeUrl = file.url
				this.dialogVisible2 = true;
			},
			handleDownload(file) {
				let file2 = {
					url: this.inputForm.accountHolderFront
				}
				toHref(file2)
			},
			handleDownload2(file) {
				let file2 = {
					url: this.inputForm.accountHolderOpposite
				}
				toHref(file2)
			},
			handleRemove(file, fileList) {
				this.hideUploadEdit = false
				// 如果需要删除图片信息，可以根据file或其他标识从相应的数据结构中删除信息
				const fileIndex = this.fileList.indexOf(file);
				if (fileIndex !== -1) {
					this.fileList.splice(fileIndex, 1); // 从fileList中删除该图片信息
				}
			},
			handleRemove2(file, fileList) {
				this.hideUploadEdit2 = false
				// 如果需要删除图片信息，可以根据file或其他标识从相应的数据结构中删除信息
				const fileIndex = this.fileList2.indexOf(file);
				if (fileIndex !== -1) {
					this.fileList2.splice(fileIndex, 1); // 从fileList中删除该图片信息
				}
			},
		}
	}
</script>
